#!/bin/bash

# cannot build on sl5 because it does not recognize gcc 4.1 headers

pkgver=v3_1
pkgdotver=3.1

source ${PRODUCTS}/setup
OS=`uname`
if [ ${OS} = "Darwin" ]
then
    flvr=`ups flavor -2`
else
    flvr=`ups flavor`
fi
pkgdir=${PRODUCTS}/clang/${pkgver}/${flvr}

if [ -z ${flvr} ]
then
   echo "ERROR: could not determine flavor for this platform"
   echo "       something is very wrong"
   exit 1
fi

mkdir -p ${pkgdir}/build
if [ ! -d ${pkgdir}/build ]
then
   echo "ERROR: failed to create ${pkgdir}/build"
   exit 1
fi
cd ${pkgdir}/build

set -x

../../source/llvm-${pkgdotver}.src/configure --enable-optimized --prefix=${pkgdir}
make 
make install


set +x

if [ ! -d ${pkgdir}/bin ]
then
   echo "ERROR: failed to create ${pkgdir}/bin"
   echo "       Something is very wrong"
   exit 1
fi

if [ ! -d ${pkgdir}/lib ]
then
   echo "ERROR: failed to create ${pkgdir}/lib"
   echo "       Something is very wrong"
   exit 1
fi

# this should not complain
echo "Finished building clang for flavor ${flvr}"
echo "Declaring clang ${pkgver} for flavor ${flvr}"
if [ ${OS} = "Darwin" ]
then
   ups declare clang ${pkgver} -r clang/${pkgver} -2 -m clang.table
else 
   ups declare clang ${pkgver} -r clang/${pkgver} -4 -m clang.table 
fi
setup clang ${pkgver} 
echo "clang libraries are at  ${CPPUNIT_LIB}"

# fixing embedded path - not right yet
mv ${CLANG_FQ_DIR}/include/llvm/Config/llvm-config.h ${CLANG_FQ_DIR}/include/llvm/Config/llvm-config.h.bak
cat ${CLANG_FQ_DIR}/include/llvm/Config/llvm-config.h.bak | sed 's%/home/garren/products/clang/v3_1/Linux64bit+2.6-2.12%${CLANG_FQ_DIR}%' > ${CLANG_FQ_DIR}/include/llvm/Config/llvm-config.h
mv ${CLANG_FQ_DIR}/include/llvm/Config/config.h ${CLANG_FQ_DIR}/include/llvm/Config/config.h.bak
cat ${CLANG_FQ_DIR}/include/llvm/Config/config.h.bak | sed 's%/home/garren/products/clang/v3_1/Linux64bit+2.6-2.12%${CLANG_FQ_DIR}%' > ${CLANG_FQ_DIR}/include/llvm/Config/config.h

exit 0
